package com.qgs.dc.s7.my.s7connector;

import com.qgs.dc.s7.my.s7connector.api.DaveArea;
import com.qgs.dc.s7.my.s7connector.api.S7Connector;
import com.qgs.dc.s7.my.s7connector.api.factory.S7ConnectorFactory;
import com.qgs.dc.s7.my.s7connector.api.utils.ByteUtils;
import com.qgs.dc.s7.my.s7connector.type.PlcVar;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.text.ParseException;
import java.util.Arrays;
import java.util.List;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2021/12/10 10:17
 */
public class MainForWrite {
    public static void main(String[] args) throws IOException, ParseException {
        //Create connection
        S7Connector connector =
                S7ConnectorFactory
                        .buildTCPConnector()
                        .withHost("192.168.0.51")
                        .withRack(0) //optional     rack 是机架号
                        .withSlot(0) //optional     slot 是插槽号
                        .build();


        {
            connector.write(DaveArea.DB, 3, 3266,1,ByteUtils.boolToBytes(true), PlcVar.BOOL);
//            byte[] bool = connector.read(DaveArea.DB, 3, 1, 3266,1);
//            Boolean b = (Boolean)PlcVar.BOOL.toObject(bool);
//            System.out.println("DB3.3266.1-boolean : " + b);

        }


        //非常规
        {
            //注意1:
            //lreal 要小端（拿到字节流要翻转一下）
            //参数一：读取方式，一般默认是DB区域块
            //参数二：区域块编号
            //参数三：区域数据类型大小，int 2字节，real 4字节
            //参数四：区域偏移量
            //[-64, 40, 51, 51, 51, 51, 51, 51]    -64==0xc0(要翻转一下才能用)
            //1100 0000  0010 1000  0011 0011  0011 0011  0011 0011  0011 0011  0011 0011  0011 0011



//            byte[] lreal_content = ByteUtils.lrealToBytes(Double.parseDouble("-111.1"));
            byte[] lreal_content = PlcVar.LREAL.toBytes(-121.1);
            connector.write(DaveArea.DB, 3, 26,lreal_content);
            byte[] lreal = connector.read(DaveArea.DB, 3, 8, 26);
//            Double aDouble = ByteUtils.lrealbytesToDouble(lreal);
            Double ad = (Double)PlcVar.LREAL.toObject(lreal);
            System.out.println("DB3.26-lreal : "+ ad);

            //byte[] real_content = ByteUtils.realToBytes(Float.valueOf("-11.2"));
            byte[] real_content = PlcVar.REAL.toBytes(-12.1);
            connector.write(DaveArea.DB, 3, 22,real_content);
            byte[] real = connector.read(DaveArea.DB, 3, 4, 22);
            //ByteUtils.realbytesToFloat(real)
            Float o = (Float)PlcVar.REAL.toObject(real);
            System.out.println("DB3.22-real : "+ o);

        }

        {

            //data 是有符号的双字节
            //注意2：
            //[2, -38] 就就代表1990-1-1 因为这就是其实位置。 后续位置要1990+n的       D#1992-01-01
            //[4, 72]    1993-1-1
            //0000 0100  0100 1000    72+1024=1096   1990-1-1 + 1096(天) = 1993-1-1
            byte[] date = connector.read(DaveArea.DB, 3, 2, 42);
//            System.out.println("DB3.42-DATE : "+addDate("1990-01-01",byte2short(date)));
//            Long aLong = Long.valueOf(ByteUtils.toInt(date[0], date[1]).toString());
//            String s = ByteUtils.addDate("1990-01-01", aLong);
            String s = (String) PlcVar.DATE.toObject(date);
            System.out.println("DB3.42-DATE : "+s);
        }

        {
            //[7, -78, 1, 1, 5, 0, 0, 0, 0, 0, 0, 0]  DTL#1970-01-01-00:00:00    1998-1-1 星期五 0.0.0.0
            //0000 0111  (1100 1110)=>(1011 0010  178)   178+256+512+1024=1970
            //(注意：第二个字节是负数要转成补码形式表示(因为在通行传输中 字节是原码形式传输的，但是java中long int byte... 都是以补码形式保存的 java帮你自动保存了其实这是不对的所以你要转换一下) 参考https://blog.csdn.net/csdn_ds/article/details/79106006)
            //[7, -68, 1, 21, 2, 0, 0, 0, 0, 0, 0, 0]
            //0000 0111  (1100 0100)=>(1011 1100 188)  188+256+512+1024=1980
            byte[] dtl = connector.read(DaveArea.DB, 3, 12, 44);
//            byte[] year = new byte[2];
//            year[0] = dtl[0];
//            year[1] = dtl[1];
//            Integer yearInt = ByteUtils.toInt(year[0], year[1]);
//            Integer monthInt = ByteUtils.toInt(dtl[2]);
//            Integer dayInt = ByteUtils.toInt(dtl[3]);
//            Integer worddayInt = ByteUtils.toInt(dtl[4]);
//            Integer hourInt = ByteUtils.toInt(dtl[5]);
//            Integer minuInt = ByteUtils.toInt(dtl[6]);
//            Integer secondInt = ByteUtils.toInt(dtl[7]);


//            System.out.println("DB3.12-DTL : " + byteArrayByteUtils.toUInt(year)+"-"+byteArrayByteUtils.toUInt(month));
            String o = (String)PlcVar.DTL.toObject(dtl);
            System.out.println("DB3.44-DTL : " + o );
        }

        {
            //[59, -102, -55, -1]    T#11D_13H_46M_39S_999MS
            //0011 1011
            byte[] time = connector.read(DaveArea.DB, 3, 4, 34);
//            Integer integer = ByteUtils.toInt(time[0], time[1], time[2], time[3]);
            Integer i = (Integer) PlcVar.TIME.toObject(time);
            System.out.println("DB3.34-time : " + i +" ms");
        }

        //常规

        //int 相关（sint、int、dint 。。 usint、uint、udint）
        {
            //[11]   //[9] ==>2304
//            byte[] usint_content = ByteUtils.usintToBytes(9);

            byte[] usint_content = PlcVar.USINT.toBytes(9);
            connector.write(DaveArea.DB, 3, 8,usint_content);
            byte[] usint = connector.read(DaveArea.DB, 3, 1, 8);
//            Integer integer = ByteUtils.toUInt(usint[0]);
            Integer integer = (Integer) PlcVar.USINT.toObject(usint);
            System.out.println("DB3.8-usint : " + integer);

//            byte[] bytes = ByteUtils.sintToBytes(-9);
            byte[] bytes = PlcVar.SINT.toBytes(-9);
            connector.write(DaveArea.DB, 3, 9,bytes);
            byte[] sint = connector.read(DaveArea.DB, 3, 1, 9);
//            Integer integer1 = ByteUtils.toInt(sint[0]);
            Integer integer1 = (Integer) PlcVar.SINT.toObject(usint);
            System.out.println("DB3.9-sint : " + integer1);

//            byte[] unit_content = ByteUtils.uintToBytes(9);
            byte[] unit_content = PlcVar.UINT.toBytes(9);
            connector.write(DaveArea.DB, 3, 10,unit_content);
            byte[] uint = connector.read(DaveArea.DB, 3, 2, 10);
            System.out.println("DB3.10-uint : " + ByteUtils.toUInt(uint[0],uint[1]));

            //[-1, -111]  -111
            //[-1, -64]   -64
            //[-4, 25]    -999
            //byte[] bytes1 = ByteUtils.intToBytes(-99);
            byte[] bytes1 = PlcVar.INT.toBytes(-99);
            connector.write(DaveArea.DB, 3, 12,bytes1);
            byte[] ints = connector.read(DaveArea.DB, 3, 2, 12);
            System.out.println("DB3.12-ints : " + ByteUtils.toInt(ints[0],ints[1]));


//            byte[] bytes2 = ByteUtils.dintToBytes(-999);
            byte[] bytes2 = PlcVar.DINT.toBytes(-999);
            connector.write(DaveArea.DB, 3, 14,bytes2);
            byte[] dint = connector.read(DaveArea.DB, 3, 4, 14);
            System.out.println("DB3.14-dint : " + ByteUtils.toInt(dint[0],dint[1],dint[2],dint[3]));

//            byte[] bytes3 = ByteUtils.udintToBytes(99);

            byte[] bytes3 = PlcVar.UDINT.toBytes(99);
            connector.write(DaveArea.DB, 3, 18,bytes3);
            byte[] udint = connector.read(DaveArea.DB, 3, 4, 18);
            System.out.println("DB3.18-udint : " + ByteUtils.toUInt(udint[0],udint[1],udint[2],udint[3]));

        }

        {
            // [0]
//            byte[] bytes = ByteUtils.boolToBytes(false);
            byte[] bytes = PlcVar.BOOL.toBytes(false);
            connector.write(DaveArea.DB, 3, 0,bytes);
            byte[] bool = connector.read(DaveArea.DB, 3, 1, 0);
            System.out.println("DB3.0-boolean : " + ByteUtils.toBoolean(bool));

            //byte 目前读取以 有符号的十进制
            //[8]
            //[-63]
            //1011 1111
//            byte[] setbytes = ByteUtils.setbytes(Byte.valueOf((byte) 0xFF));
            byte[] setbytes = PlcVar.BYTE.toBytes((byte)0xFF);
            connector.write(DaveArea.DB, 3, 1,setbytes);
            byte[] byteOne = connector.read(DaveArea.DB, 3, 1, 1);
            System.out.println("DB3.1-byteOne-有符号 : " + ByteUtils.toInt(byteOne[0]));   //有符号 整形
            System.out.println("DB3.1-byteOne-无符号 : " + ByteUtils.toUInt(byteOne[0]));  //无符号 整形


            // [0, 5]  word 可 2/8/16进制  可无符号 可有符号，就看你真没用
//            byte[] bytes1 = ByteUtils.wordToBytes(Short.valueOf("-55"));
            byte[] bytes1 = PlcVar.WORD.toBytes(-55);
            connector.write(DaveArea.DB, 3, 2,bytes1);
            byte[] word = connector.read(DaveArea.DB, 3, 2, 2);
            System.out.println("DB3.2-word : " + ByteUtils.toInt(word[0],word[1]));

            // [-1, -1, -1, -4] 把java自动转换成byte类型 的补码形式 ,如果电控变量是这个要问下他是无符号还是有符号的。
            // [FF, FF, FF, FC] 原码
            byte[] bytes2 = PlcVar.DWORD.toBytes(-99);
            connector.write(DaveArea.DB, 3, 4,bytes2);
            byte[] dword = connector.read(DaveArea.DB, 3, 4, 4);
            System.out.println("DB3.4-dword : " + ByteUtils.toInt(dword[0],dword[1],dword[2],dword[3]));  //带符号的 整形


            //plc 中char 是1个字节   注意char 和 wchar 都是ascii码格式的。
//            byte[] bytes3 = ByteUtils.charToBytes('b');
            byte[] bytes3 = PlcVar.CHAR.toBytes('b');
            connector.write(DaveArea.DB, 3, 58,bytes3);
            byte[] chars = connector.read(DaveArea.DB, 3, 1, 58);
            System.out.println("DB3.58-char : " + ByteUtils.toChar(chars));

            //plc 中wchar 是2个字节    '菜' =》[-125, -36]
//            byte[] bytes4 = ByteUtils.wcharToBytes('菜');
            byte[] bytes4 = PlcVar.WCHAR.toBytes('翔');
            connector.write(DaveArea.DB, 3, 60,bytes4);
            byte[] wchar = connector.read(DaveArea.DB, 3, 2, 60);
            System.out.println("DB3.60-wchar : " + ByteUtils.toChar(wchar));

            //n+2 个字节 （这里的n 就是实际content的字节数 如 "123"=> n=3 ;; "@123"  ==> n=4）
            //[-2, 4, 64, 65, 83, 68]  @ASD   前面-2 4两个字节就是上面的2字节 是无用的
            //-2 代表 字符串中存储最大的总字节数 ；  4代表字符数  后面跟着的 是内容（最多256个字节）

            //[-2, 4, 64, 65, 83, 68]  @ASD
            //[-2, 4, 64, 64, 64, 64]  @ASD
            //读取字符串 要事先知道长度，否则可能读取的字符串长度不完整
            String s = "你好啊呢";
//            byte[] str_content = ByteUtils.strToBytes(s);
//            byte[] str_content = PlcVar.STRING.toBytes(s);
//            connector.write(DaveArea.DB, 3, 62 , str_content);
            //byte[] str = connector.read(DaveArea.DB, 3, str_content.length, 62);
            //[-2, 6, -60, -29, -70, -61]
            //[-2, 8, -53, -58, -75, -60]
            byte[] str = connector.read(DaveArea.DB, 3, 10, 62);
            String string = ByteUtils.toStr(str);
            System.out.println("DB3.62-str : " +string );
            //下面这种方式读取字符串，，是指定长度的，
            //byte[] str2 = connector.read(DaveArea.DB, 3, 7, 62);

        }

        {
            //byte 占用一个字节，如果是数组的话，就读取2个（要事先知道，点表规定数组长度），实际就是读取 DB3.830
            //bytes = byteLength * arrayLength     举例：1（byteLength） * 2（arrayLength） =2（bytes）
            boolean[] booleanArray = new boolean[2];
            booleanArray[0] = true;
            booleanArray[1] = true;
//            byte[] bytes1 = ByteUtils.booleanArrayToBytes(booleanArray);
            byte[] bytes1 = PlcVar.BOOL_Array.toBytes(booleanArray);
            connector.write(DaveArea.DB, 3, 830 , bytes1);
            byte[] boolArrays = connector.read(DaveArea.DB, 3, 2, 830);
//            List<Boolean> booleans = ByteUtils.toBoolArray(boolArrays);
            List<Boolean> booleans = (List<Boolean>) PlcVar.BOOL_Array.toObject(boolArrays);
            System.out.println("DB3.830-boolArrays : " +booleans );


            //注意 write的长度，要和plc中定义的长度要一致
            byte[] write_byteArrays = new byte[2];
            write_byteArrays[0] = 1;
            write_byteArrays[1] = 2;
            byte[] bytes2 = PlcVar.BYTE_Array.toBytes(write_byteArrays);
            connector.write(DaveArea.DB, 3, 832 , bytes2);
            byte[] byteArrays = connector.read(DaveArea.DB, 3, 2, 832);
//            List<Byte> bytes = ByteUtils.toByteArray(byteArrays);
            List<Byte> bytes = (List<Byte>) PlcVar.BYTE_Array.toObject(boolArrays);
            System.out.println("DB3.832-byteArrays : " +bytes );


            short[] shortArrays_content = new short[2];
            shortArrays_content[0] = 1;
            shortArrays_content[1] = -1;
//            byte[] bytes4 = ByteUtils.wordArrayToBytes(shortArrays_content);
            byte[] bytes4 = PlcVar.WORD_Array.toBytes(shortArrays_content);
            connector.write(DaveArea.DB, 3, 836 ,bytes4);
            byte[] wordArrays = connector.read(DaveArea.DB, 3, 4, 836);
            List<Integer> words = ByteUtils.toWordArray(wordArrays);
            System.out.println("DB3.836-wordArrays : " +words );

            int[] intArrays_content = new int[2];
            intArrays_content[0] = 1;
            intArrays_content[1] = -1;
//            byte[] bytes5 = ByteUtils.dwordArrayToBytes(intArrays_content);
            byte[] bytes5 = PlcVar.DWORD_Array.toBytes(intArrays_content);
            connector.write(DaveArea.DB, 3, 840 ,bytes5);
            byte[] dwordArrays = connector.read(DaveArea.DB, 3, 8, 840);
            List<Integer> dwords = ByteUtils.toDWordArray(dwordArrays);
            System.out.println("DB3.840-dwordArrays : " +dwords );


            char[] charArrays_content = new char[2];
            charArrays_content[0] = '1';
            charArrays_content[1] = 'b';
//            byte[] bytes3 = ByteUtils.charArrayToBytes(charArrays_content);
            byte[] bytes3 = PlcVar.CHAR_Array.toBytes(charArrays_content);
            connector.write(DaveArea.DB, 3, 834 ,bytes3);
            byte[] charArrays = connector.read(DaveArea.DB, 3, 2, 834);
            List<Character> chars = ByteUtils.toCharArray(charArrays);
            System.out.println("DB3.834-charArrays : " +chars );


            int[] sintArrays_content = new int[2];
            sintArrays_content[0] = 1;
            sintArrays_content[1] = -1;
//            byte[] bytes6 = ByteUtils.sintArrayToBytes(sintArrays_content);
            byte[] bytes6 = PlcVar.SINT_Array.toBytes(sintArrays_content);
            connector.write(DaveArea.DB, 3, 852 ,bytes6);
            byte[] sintArrays = connector.read(DaveArea.DB, 3, 2, 852);
            List<Integer> sints = ByteUtils.toSIntArray(sintArrays);
            System.out.println("DB3.852-sintArrays : " +sints );


            int[] iintArrays_content = new int[2];
            iintArrays_content[0] = 12;
            iintArrays_content[1] = -21;
//            byte[] bytes7 = ByteUtils.intArrayToBytes(iintArrays_content);
            byte[] bytes7 = PlcVar.INT_Array.toBytes(iintArrays_content);
            connector.write(DaveArea.DB, 3, 848 ,bytes7);
            byte[] intArrays = connector.read(DaveArea.DB, 3, 4, 848);
            List<Integer> ints = ByteUtils.toIntArray(intArrays);
            System.out.println("DB3.848-intArrays : " +ints );


            //todo here
            int[] dintArrays_content = new int[2];
            dintArrays_content[0] = 12;
            dintArrays_content[1] = -21;
            //ByteUtils.dintArrayToBytes(dintArrays_content)
            byte[] bytes11 =PlcVar.DINT_Array.toBytes(dintArrays_content);
            connector.write(DaveArea.DB, 3, 854 ,bytes11);
            byte[] dintArrays = connector.read(DaveArea.DB, 3, 8, 854);
            List<Integer> dints = ByteUtils.toDIntArray(dintArrays);
            System.out.println("DB3.852-dintArrays : " +dints);


            int[] uintArrays_content = new int[3];
            uintArrays_content[0] = 12;
            uintArrays_content[1] = 99;
            uintArrays_content[2] = 1;
            //byte[] bytes9 = ByteUtils.uintArrayToBytes(uintArrays_content);
            byte[] bytes9 = PlcVar.UINT_Array.toBytes(uintArrays_content);
            connector.write(DaveArea.DB, 3, 3256 ,bytes9);
            byte[] uintArrays = connector.read(DaveArea.DB, 3, 6, 3256);
            List<Integer> uints = ByteUtils.toUIntArray(uintArrays);
            System.out.println("DB3.3256-uintArrays : " +uints );



            int[] usintArrays_content = new int[3];
            usintArrays_content[0] = 12;
            usintArrays_content[1] = 99;
            usintArrays_content[2] = 1;
//            byte[] bytes8 = ByteUtils.usintArrayToBytes(usintArrays_content);
            byte[] bytes8 = PlcVar.USINT_Array.toBytes(usintArrays_content);
            connector.write(DaveArea.DB, 3, 3240 ,bytes8);
            byte[] usintArrays = connector.read(DaveArea.DB, 3, 3, 3240);
            List<Integer> usints = ByteUtils.toUSIntArray(usintArrays);
            System.out.println("DB3.3240-usintArrays : " +usints );


            int[] udintArrays_content = new int[3];
            udintArrays_content[0] = 12;
            udintArrays_content[1] = 99;
            udintArrays_content[2] = 1;
//            byte[] bytes10 = ByteUtils.udintArrayToBytes(udintArrays_content);
            byte[] bytes10 = PlcVar.UDINT_Array.toBytes(udintArrays_content);
            connector.write(DaveArea.DB, 3, 3244 ,bytes10);
            byte[] udintArrays = connector.read(DaveArea.DB, 3, 12, 3244);
            List<Long> udints = ByteUtils.toUDIntArray(udintArrays);
            System.out.println("DB3.852-udintArrays : " +udints);

        }





        //Write to DB100 10 bytes



        //connector.write(DaveArea.DB, 3, 830, byteArrays);

        //Close connection
        connector.close();
    }



}
